package JavaDynamicProxy;

import java.lang.reflect.*;

public class LoggingProxy implements InvocationHandler {
	private Object proxiedObject;
	
	public static Object getProxy(Object proxiedObject) {
		ClassLoader clsLoader = proxiedObject.getClass().getClassLoader();
		Class[] interfaces = proxiedObject.getClass().getInterfaces();
		InvocationHandler handler = new LoggingProxy(proxiedObject);
		return Proxy.newProxyInstance(clsLoader, interfaces, handler);
	}
	
	private LoggingProxy(Object proxiedObject) {
		this.proxiedObject = proxiedObject;
	}
	
	public Object invoke(Object obj, Method method, Object[] parms) throws Throwable {
		logCall(method, parms);
		Object result = method.invoke(proxiedObject, parms);
		return result;
	}
	
	private void logCall(Method method, Object[] parms) {
		System.out.println(method.toString());
	}

}