#!/bin/sh -v

# This script will compile and run example 3.
# This script assumes that Java is installed in /usr/java/j2sdk1.4.0_02
# (modify if not), and that the Java bin directory is in your PATH.
# It also assumes that you have gcc, ar and ld in your PATH.

# Create the rootlib library
gcc -c rootlib.c
ar rv librootlib.a rootlib.o

# Compile the Java class
javac RootFinder.java

# Generate a C header file
javah -jni RootFinder

# Compile the implementation of the C interface to the RootFinder function
gcc -c -I/usr/java/j2sdk1.4.0_02/include \
       -I/usr/java/j2sdk1.4.0_02/include/linux RootFinderImp.c

# Convert it to a shared library
ld -G RootFinderImp.o -o libCJavaInterface.so librootlib.a -lm -lc -lpthread

# Set the search path for shared libraries
export LD_LIBRARY_PATH=.

# Run the Java program
java RootFinder
