// The VectorAdd.java file

public class VectorAdd
{

  // Declaration of the Native (C) function
  private native int vectoradd(int n, double[] a, double[] b, double[] c);

  static
    {
      // The runtime system executes a class's static
      // initializer when it loads the class.
      System.loadLibrary("CJavaInterface");
    }

  // The main program
  public static void main(String[] args)
    {
      double a[], b[], c[];
      int i, n, retCode;

      // Create an object of class VectorAdd
      VectorAdd vecadd = new VectorAdd();

      n = 4;

      a = new double[n];
      b = new double[n];
      c = new double[n];

      // Initialize two vectors of length 4
      a[0] = 1.0;
      a[1] = 2.0;
      a[2] = 3.0;
      a[3] = 4.0;

      b[0] = 2.0;
      b[1] = 3.0;
      b[2] = 4.0;
      b[3] = 5.0;

      System.out.println();
      System.out.println("Call of vector addition routine vectoradd");
      System.out.println();

      // Print the input vectors a and b
      System.out.println("Input vector a:");
      for (i = 0; i < n; i++)
          System.out.print(" " + a[i]);
      System.out.println();
      System.out.println();
      System.out.println("Input vector b:");
      for (i = 0; i < n; i++)
          System.out.print(" " + b[i]);
      System.out.println();
      System.out.println();

      // Call method vectoradd of object vecadd
      retCode = vecadd.vectoradd(n, a, b, c);

      if (retCode == 0)
        {
          // Print the result vector c
          System.out.print("Result vector c = a + b:\n");
          for (i = 0; i < n; i++)
            System.out.print(" " + c[i]);
          System.out.println();
        }
    }
}
