/* The VectorAddImp.c file */

#include <jni.h>         /* Java Native Interface headers */
#include "VectorAdd.h"   /* Auto-generated header created by javah -jni */

/* Our C definition of the function vectoradd declared in VectorAdd.java */
JNIEXPORT jint JNICALL Java_VectorAdd_vectoradd
  (JNIEnv *env, jobject obj, jint n, jdoubleArray a, jdoubleArray b,
   jdoubleArray c)
{
  /* First extract the arrays from Java */
  jdouble *apt, *bpt, *cpt;
  jint i;
  jboolean isCopy;

  apt = (*env)->GetDoubleArrayElements(env, a, &isCopy);
  bpt = (*env)->GetDoubleArrayElements(env, b, &isCopy);
  cpt = (*env)->GetDoubleArrayElements(env, c, &isCopy);

  /* Add vector a to b, putting the result in vector c */
  for (i = 0; i < n; i++)
    cpt[i] = apt[i] + bpt[i];

  /* Release the array elements back to Java */
  (*env)->ReleaseDoubleArrayElements(env, a, apt, 0);
  (*env)->ReleaseDoubleArrayElements(env, b, bpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, c, cpt, 0);

  return 0;
}
