#!/bin/sh -v

# This script will compile and run example 2.
# This script assumes that Java is installed in /usr/java/j2sdk1.4.0_02
# (modify if not), and that the Java bin directory is in your PATH.
# It also assumes that you have gcc and ld in your PATH.

# Compile the Java class
javac VectorAdd.java

# Generate a C header file
javah -jni VectorAdd

# Compile the implementation of the C interface to the VectorAdd function
gcc -c -I/usr/java/j2sdk1.4.0_02/include \
       -I/usr/java/j2sdk1.4.0_02/include/linux VectorAddImp.c

# Convert it to a shared library
ld -G VectorAddImp.o -o libCJavaInterface.so -lm -lc -lpthread

# Set the search path for shared libraries
export LD_LIBRARY_PATH=.

# Run the Java program
java VectorAdd
