import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class BrokenThreadLocalDateParser implements DateParser {

  // The static modifier has been omitted on the following line.
  private final ThreadLocal DATE_PARSER_THREAD_LOCAL = new ThreadLocal() {
    protected Object initialValue() {
      return new SimpleDateFormat("dd/MM/yyyy");
    }
    protected void finalize() throws Throwable {
      System.out.println("Finalizing " + hashCode());
      super.finalize();
    }
  };

  public Date parse(String text) throws ParseException {
    return ((DateFormat) DATE_PARSER_THREAD_LOCAL.get()).parse(text);
  }

}
