import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ThreadLocalDateParser implements DateParser {
	
	private static final ThreadLocal DATE_PARSER_THREAD_LOCAL = new ThreadLocal() {
		protected Object initialValue() {
			return new SimpleDateFormat("dd/MM/yyyy");
		}
	};
	
	public Date parse(String text) throws ParseException {
		return ((DateFormat) DATE_PARSER_THREAD_LOCAL.get()).parse(text);
	}
	
}
